backend/urls.py
from django.urls import path
from backend import views

app_name = 'backend'

urlpatterns = [
    path('accounts/signup/', views.signup, name='signup'),
    path('accounts/signup/check/', views.signup_check, name='signup_check'),
    path('accounts/login/', views.login, name='login'),
    path('accounts/login/identify/', views.identify, name='identify'),
    path('accounts/logout/', views.logout, name='logout'),
    path('accounts/verify/', views.verify, name='verify'),
    path('accounts/verify/resend', views.verify_resend, name='verify_resend'),
    path('accounts/recovery/', views.recovery, name='recovery'),
    path('accounts/edit/', views.edit, name='edit'),

    path('interactions/follow/<int:pk>/', views.follow, name='follow'),
    path('interactions/unfollow/<int:pk>/', views.unfollow, name='unfollow'),

    path('interactions/up-vote/<int:pk>/', views.up_vote, name='up_vote'),
    path('interactions/down-vote/<int:pk>/', views.down_vote, name='down_vote'),

    path('thread/<slug>/', views.thread, name='thread'),
    path('thread/<int:pk>/edit/', views.thread_edit, name='thread_edit'),
    path('thread/<int:pk>/delete/', views.thread_delete, name='thread_delete'),
    path('thread/<int:pk>/reply/', views.thread_reply, name='thread_reply'),

    path('report/', views.report, name='report'),
    path('report/<int:pk>/edit', views.report_edit, name='report_edit'),

    path('observation/<int:pk>/reply', views.observation_reply, name='observation_reply'),
    path('observation/names/', views.observation_names, name='observation_names'),

    path('maps/', views.maps, name='maps'),
    path('search/', views.search, name='search'),
    path('language/<code>/', views.language, name='language'),

    path('mail-test/', views.mail_test, name='mail-test'),
]

config/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from django.views.static import serve

urlpatterns = [
    path('', include('frontend.urls')),
    path('api/', include('backend.urls')),
    path('admin/', admin.site.urls),
    path('_nested_admin/', include('nested_admin.urls')),
]

handler404 = 'frontend.views.handler404'
handler500 = 'frontend.views.handler500'

if not settings.DEBUG:
    # static use white noise
    urlpatterns += path('media/<path:path>/', serve, {'document_root': settings.MEDIA_ROOT}),
else:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

frontend/urls.py
from django.urls import path
from django.views import defaults
from frontend import views

app_name = 'frontend'

urlpatterns = [
    path('', views.home, name='home'),
    path('about/', views.about, name='about'),
    path('team/', views.team, name='team'),
    path('guidelines/', views.guidelines, name='guidelines'),
    path('elasmoid/', views.elasmoid, name='elasmoid'),
    path('iecsn/', views.iecsn, name='iecsn'),
    path('maps/', views.maps, name='maps'),
    path('articles/', views.articles, name='articles'),
    path('articles/<int:pk>/', views.article, name='article'),
    path('report/', views.report, name='report'),
    path('report/tna/', views.report_tna, name='report_tna'),
    path('search/', views.search, name='search'),
    path('s/<slug>/', views.static, name='static'),

    path('signup/', views.signup, name='signup'),
    path('login/', views.login, name='login'),
    path('login/identify/', views.identify, name='identify'),
    path('recovery/', views.recovery, name='recovery'),
    path('verify/', views.verify, name='verify'),

    path('contributor/observations/', views.contributor_observations, name='contributor_observations'),
    path('contributor/observation/<int:pk>/', views.contributor_observation, name='contributor_observation'),
    path('contributor/leaderboard/', views.contributor_leaderboard, name='contributor_leaderboard'),
    path('contributor/profile/', views.contributor_profile, name='contributor_profile'),
    path('contributor/profile/edit/', views.contributor_profile_edit, name='contributor_profile_edit'),
    path('contributor/profile/<username>/', views.contributor_profile_user, name='contributor_profile_user'),

    path('forum/topics/', views.forum_topics, name='forum_topics'),
    path('forum/thread/<int:pk>/', views.forum_thread, name='forum_thread'),
    path('forum/thread/<int:pk>/edit/', views.forum_thread_edit, name='forum_thread_edit'),
    path('forum/threads/<slug>/', views.forum_threads, name='forum_threads'),
    path('forum/threads/<slug>/create', views.forum_thread_create, name='forum_thread_create'),

    path('form/report', views.form_report, name='form_report'),
    path('form/report/<int:pk>/edit', views.form_report_edit, name='form_report_edit'),
]

frontend/models.py
from django.db import models

# Create your models here.

frontend/views.py
from django.contrib.auth.decorators import login_required
from django.core.paginator import Paginator
from django.db.models import F, Q, Case, Value, When
from django.http import Http404
from django.shortcuts import render, redirect
from urllib.parse import unquote

from backend.models import (
    Observation,
    ObservationImage,
    ObservationReply,
    User,
    UserConnection,
    Topic,
    Thread,
    ThreadReply,
    ThreadVote,
    Article,
    Page,
    Section,
    SectionImage,
    Navigation,
    SubNavigation,
)
from frontend import utils

def static(request, slug):
    lang = utils.get_session_lang(request)    
    template_name = f'{lang}/pages/static/base.html'
    
    pages = Page.objects.filter(slug=slug)

    if not pages.exists():
        raise Http404()
    
    page = pages.first()
    preview = request.GET.get('preview', False)
    
    if not preview and not page.visibility:
        raise Http404()

    mapper = list()
    sections = Section.objects.filter(level=pages.first()).order_by('order')
    for section in sections:
        section_images = SectionImage.objects.filter(level=section).order_by('pk')
        mapper.append((section, section_images))

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'mapper': mapper,
    }

    return render(request, template_name, response)

def home(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/home.html'

    observations = Observation.objects.filter(status='VERIFIED')
    encounter_count = observations.count()
    province_count = observations.values_list('province', flat=True).distinct().count()
    species_count = observations.values_list('scientific_name', flat=True).distinct().count()

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 1,
        'encounter_count': encounter_count,
        'province_count': province_count,
        'species_count': species_count,
    }
    return render(request, template_name, response)


def about(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/about.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def team(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/team.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def iecsn(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/iecsn.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def guidelines(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/guidelines.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 3
    }
    return render(request, template_name, response)


def elasmoid(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/elasmoid.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 3
    }
    return render(request, template_name, response)


def report(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/report.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


def report_tna(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/report-tna.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


@login_required
def form_report(request):
    lang = utils.get_session_lang(request)
    user = User.objects.get(username=request.user.username)
    page = 'report.html' if user.is_verified else 'verify.html'
    template_name = f'{lang}/forms/{page}'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


def maps(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/maps.html'

    gallery = ObservationImage.objects.filter(observation__status='VERIFIED').order_by('-pk')[:6]
    years = [date.year for date in Observation.objects.dates('datetime', 'year')]

    observations = Observation.objects.filter(status='VERIFIED')
    encounter_count = observations.count()
    province_count = observations.values_list('province', flat=True).distinct().count()
    species_count = observations.values_list('scientific_name', flat=True).distinct().count()

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 5,
        'gallery': gallery,
        'years': years,
        'encounter_count': encounter_count,
        'province_count': province_count,
        'species_count': species_count,
    }
    return render(request, template_name, response)


def articles(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/articles.html'

    articles = Article.objects.all().order_by('-created_at')
    
    tag = request.GET.get('tag')
    if tag:
        q_objects = Q(articletag__en_tag__icontains=tag) if lang == 'en' else Q(articletag__id_tag__icontains=tag)
        articles = articles.filter(q_objects).distinct()

    paginator = Paginator(articles, 12)
    page_number = request.GET.get('page', 1)
    paginator_object = paginator.get_page(page_number)
    page_range = paginator.get_elided_page_range(number=page_number)

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 6,
        'tag': tag,
        'paginator_object': paginator_object,
        'page_range': page_range,
    }

    return render(request, template_name, response)


def article(request, pk):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/article.html'
    article = Article.objects.get(pk=pk)
    article_tags = utils.get_article_tags(article, lang)
    article_url =  "{0}://{1}{2}".format(request.scheme, request.get_host(), request.path)

    q_objects = Q()
    for tag in article_tags:
        q_objects |= Q(articletag__en_tag__icontains=tag) if lang == 'en' else Q(articletag__id_tag__icontains=tag)

    related_articles = Article.objects.all().filter(q_objects).exclude(pk=pk).distinct().order_by('-created_at')[:3]
    
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 6,
        'article': article,
        'article_url': article_url,
        'related_articles': related_articles,
    }

    return render(request, template_name, response)


def identify(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/identify.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def recovery(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/recovery.html'
    token = request.GET.get('token', None)
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'token': token
    }
    return render(request, template_name, response)


def login(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/login.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def signup(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/signup.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def search(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/search.html'

    observations = Observation.objects.filter(status='VERIFIED').order_by('-created_at')
    observation_images = ObservationImage.objects.all()

    category_shark = observations.filter(category='shark').count()
    category_ray = observations.filter(category='ray').count()
    category_chimaera = observations.filter(category='chimaera').count()

    queries = request.GET.get('query', None)

    if queries:
        queries = unquote(queries)
        for query in queries.split():
            observations = observations.filter(
                Q(common_name__icontains=query) |
                Q(scientific_name__icontains=query) |
                Q(location__icontains=query) |
                Q(province__icontains=query) |
                Q(reporter__first_name__icontains=query) |
                Q(reporter__last_name__icontains=query) |
                Q(submitter__icontains=query)
            )

    category = request.GET.get('category', None)
    if category:
        observations = observations.filter(category=category)

    mapper = list()
    for observation in observations:
        observation_image = None
        images = observation_images.filter(observation=observation)
        if images.exists():
            observation_image = images.first()

        mapper.append((observation, observation_image))

    paginator = Paginator(mapper, 5)
    page_number = request.GET.get('page', 1)
    paginator_object = paginator.get_page(page_number)
    page_range = paginator.get_elided_page_range(number=page_number)

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'query': queries,
        'category': category,

frontend/templates/id/components/footer.html
{% load static %}
<footer class="container row align-items-center py-3 mb-4 border-top">
    <div class="col-md-6 mb-0 text-muted">
        <div class="language mb-3">
            <div class="mb-2">
                <a class="no-link c-blue" href="{% url 'backend:language' 'en' %}">
                    <img class="flag me-3" src="{% static 'images/common/flags/en.svg' %}" width="32"/> English
                </a>
            </div>
            <div class="mb-2">
                <a class="no-link c-blue" href="{% url 'backend:language' 'id' %}">
                    <img class="flag me-3" src="{% static 'images/common/flags/id.svg' %}" width="32"/> Bahasa Indonesia
                </a>
            </div>
        </div>
        <div class="text-center">
            © 2024 Elasmobranch Project Indonesia
        </div>
    </div>
    <ul class="nav col-md-6 d-none d-md-flex justify-content-end">
        <li class="nav-item">
            <a href="https://www.instagram.com/elasmobranchid/" class="nav-link c-blue">
                <i class="bi bi-instagram icon"></i>
            </a>
        </li>
        <li class="nav-item">
            <a href="https://twitter.com/elasmobranchid" class="nav-link c-blue">
                <i class="bi bi-twitter icon"></i>
            </a>
        </li>
        <li class="nav-item">
            <a href="https://www.linkedin.com/company/elasmobranchid/" class="nav-link c-blue">
                <i class="bi bi-linkedin icon"></i>
            </a>
        </li>
    </ul>
    <ul class="nav col-md-6 d-sm-flex d-md-none justify-content-center">
        <li class="nav-item">
            <a href="https://www.instagram.com/elasmobranchid/" class="nav-link c-blue">
                <i class="bi bi-instagram icon"></i>
            </a>
        </li>
        <li class="nav-item">
            <a href="https://twitter.com/elasmobranchid" class="nav-link c-blue">
                <i class="bi bi-twitter icon"></i>
            </a>
        </li>
        <li class="nav-item">
            <a href="https://www.linkedin.com/company/elasmobranchid/" class="nav-link c-blue">
                <i class="bi bi-linkedin icon"></i>
            </a>
        </li>
    </ul>
</footer>

frontend/templates/id/components/navbar.html
{% load static %}
{% load poll_extras %}

<div class="container">
    <p class="c-blue pt-3">We are currently accepting data taken since January 1<sup>st</sup> 2019</p>
</div>
<nav class="navbar navbar-expand-lg navbar-dark">
    <div class="container-fluid">
        <a class="navbar-brand" href="{% url 'frontend:home' %}">
            <img class="d-none d-md-block" src="{% static 'images/common/logos/logo.png' %}" alt="logo">
            <img class="d-md-none" src="{% static 'images/common/logos/mobile-logo.png' %}" alt="mobile logo">
        </a>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#mobileNav"
            aria-controls="mobileNav">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" tabindex="-1" id="mobileNav" aria-labelledby="mobileNavLabel">
            <ul class="navbar-nav ms-auto mb-2 mb-lg-0">
                {% for nav, sub_navs in navigation %}
                {% if not sub_navs %}
                <li class="nav-item">
                    <a class="nav-link {% if page == nav.order %} active {% endif %}" aria-current="page"
                        href="/{{ nav.url|default:'' }}">
                        {{ nav.id_name }}
                    </a>
                </li>
                {% else %}
                <li class="nav-item dropdown">
                    <a id="{{ nav.id_name }}"
                        class="nav-link {% if page == nav.order %} active {% endif %} dropdown-toggle" href="#"
                        role="button" data-bs-toggle="dropdown" aria-expanded="false">
                        {{ nav.id_name }}
                    </a>
                    <ul class="dropdown-menu" aria-labelledby="{{ nav.id_name }}">
                        {% for sub_nav in sub_navs %}
                        <li>
                            <a class="dropdown-item" href="/{{ sub_nav.url }}">
                                {{ sub_nav.id_name }}
                            </a>
                        </li>
                        {% if not forloop.last %}
                        <li>
                            <hr class="dropdown-divider">
                        </li>
                        {% endif %}
                        {% endfor %}
                    </ul>
                </li>
                {% endif %}
                {% endfor %}

                {% if request.user.is_authenticated %}
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle c-white" href="#" id="profiles" role="button"
                        data-bs-toggle="dropdown" aria-expanded="false">
                        Hi, {{ request.user.username|get_username }}
                    </a>
                    <ul class="dropdown-menu" aria-labelledby="profiles">
                        <li>
                            <a href="{% url 'frontend:contributor_profile' %}" class="dropdown-item">Profil</a>
                        </li>
                        <li>
                            <hr class="dropdown-divider">
                        </li>
                        <li>
                            <a href="{% url 'frontend:contributor_leaderboard' %}" class="dropdown-item">
                                Papan Peringkat
                            </a>
                        </li>
                        <li>
                            <hr class="dropdown-divider">
                        </li>
                        <li>
                            <a href="{% url 'frontend:contributor_observations' %}" class="dropdown-item">Observasi</a>
                        </li>
                        <li>
                            <hr class="dropdown-divider">
                        </li>
                        <li>
                            <a href="{% url 'frontend:forum_topics' %}" class="dropdown-item">Forum</a>
                        </li>
                        <li>
                            <hr class="dropdown-divider">
                        </li>
                        <li>
                            <a class="dropdown-item" href="{% url 'backend:logout' %}">
                                Keluar
                            </a>
                        </li>
                    </ul>
                </li>
                {% else %}
                <li class="nav-item">
                    <a href="{% url 'frontend:signup' %}" class="btn btn-outline-light btn-sm mt-1 mt-lg-1 ms-lg-3">
                        Daftar
                    </a>
                </li>
                <li class="nav-item">
                    <a href="{% url 'frontend:login' %}" class="btn btn-light btn-sm mt-3 mt-lg-1 ms-lg-3">
                        Masuk
                    </a>
                </li>
                {% endif %}
            </ul>
        </div>
    </div>
</nav>